using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;

namespace ShopClassLibrary
{
	public enum ShopStatusEnum 
	{
		OK					=  1,
		NOT_OK				=  0,
		INVALID_LOGIN		= -1,
		INVALID_KEY			= -2,
		INVALID_CUSTOMER_ID	= -3,
		INVALID_PRODUCT_ID	= -4,
		INSUFICIENT_STOCK	= -5,
		ERROR				= -6
	}

	/// <summary>
	/// Summary description for Comum.
	/// </summary>
	class Comum
	{
		public static string sConn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Documents and Settings\\Jos Tavares\\Work\\Docencia\\Eng Informatica\\ADAV\\Projectos\\Sales.mdb;User ID=;Password=;";

		public Comum()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		static public ShopStatusEnum ValidateUser(string sUser, string sPass)
		{
			ShopStatusEnum status = ShopStatusEnum.OK;
			OleDbCommand    oCmd  = null;
			OleDbConnection oConn = null;

			try
			{
				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				oConn = new OleDbConnection(sConn);
				oConn.Open();

				//
				// criar comando SQL a executar
				//
				oCmd = new OleDbCommand("SELECT * FROM Users WHERE User='" + sUser + "' and Pass='" + sPass + "'", oConn);

				//
				// executar o comando e obter um DataReader
				//
				OleDbDataReader oDR = oCmd.ExecuteReader();

				//
				// verificar se retornou dados 
				// ( necessrio manter a conexo aberta pois estamos a usar um DataReader)
				//
				if (oDR.HasRows)
					status = ShopStatusEnum.OK;
				else
					status = ShopStatusEnum.INVALID_LOGIN;

				oDR.Close();
			}

			catch(Exception ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex);
				status = ShopStatusEnum.ERROR;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (oConn.State == ConnectionState.Open)
					oConn.Close();
			}

			return status;
		}

		static public DataSet GetByID(string sTable, string sKeyName, long lKey)
		{
			DataSet oSet = null;
			OleDbConnection oConn = null;

			try
			{				
				//
				// criar objecto DataSet
				//
				oSet = new DataSet();

				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				oConn = new OleDbConnection(sConn);
				oConn.Open();

				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
				string sSqlCmd = "SELECT * FROM "+ sTable + " WHERE "+ sKeyName + " = "+ lKey.ToString();
				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, oConn);

				//
				// executar o comando e preencher um Dataset
				//
				oAdapter.Fill(oSet, sTable);
			}

			catch(Exception ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no mtodo 'GetByID': " + ex);
				oSet = null;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (oConn.State == ConnectionState.Open)
					oConn.Close();
			}

			return oSet;
		}

		static public ShopStatusEnum CheckIfExistsID(string sTable, string sKeyName, long lKey)
		{
			ShopStatusEnum status = ShopStatusEnum.OK;
			OleDbCommand    oCmd  = null;
			OleDbConnection oConn = null;

			try
			{
				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				oConn = new OleDbConnection(sConn);
				oConn.Open();

				//
				// criar comando SQL a executar
				//
				string sSqlCmd = "SELECT * FROM "+ sTable + " WHERE "+ sKeyName + " = "+ lKey.ToString();
				oCmd = new OleDbCommand(sSqlCmd, oConn);

				//
				// executar o comando e obter um DataReader
				//
				OleDbDataReader oDR = oCmd.ExecuteReader();

				//
				// verificar se retornou dados 
				// ( necessrio manter a conexo aberta pois estamos a usar um DataReader)
				//
				if (oDR.HasRows)
					status = ShopStatusEnum.OK;
				else
					status = ShopStatusEnum.INVALID_KEY;

				oDR.Close();
			}

			catch(Exception ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex);
				status = ShopStatusEnum.ERROR;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (oConn.State == ConnectionState.Open)
					oConn.Close();
			}


			return status;
		}

		static public DataSet FindByStringField(string sTable, string sKeyName, string sPattern, bool bFindExact)
		{
			DataSet oSet = null;
			OleDbConnection oConn = null;

			try
			{				
				//
				// criar objecto DataSet
				//
				oSet = new DataSet();

				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				oConn = new OleDbConnection(sConn);
				oConn.Open();

				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
                string sSqlCmd = "SELECT * FROM "+ sTable + " WHERE "+ sKeyName;
				if (bFindExact)
					sSqlCmd += " = '"+ sPattern + "'";
				else
					sSqlCmd += " LIKE '%"+ sPattern + "%'";

				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, oConn);

				//
				// executar o comando e preencher um Dataset
				//
				oAdapter.Fill(oSet, sTable);
			}

			catch(Exception ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no mtodo 'GetByID': " + ex);
				oSet = null;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (oConn.State == ConnectionState.Open)
					oConn.Close();
			}

			return oSet;
		}
	}
}
